import { NodeDef, Node, EditorNodeProperties } from "node-red"
import { TeamSpeak } from "ts3-nodejs-library"

export interface Ts3ConfigProps{
    host: string
    nickname: string
}

export interface Ts3ConfigCreds {
    username: string
    password: string
}

export interface Ts3ConfigData {
    getConnection(): Promise<TeamSpeak>
}

export interface Ts3ConfigConfig extends NodeDef, Ts3ConfigProps, Ts3ConfigCreds { }

export interface Ts3ConfigNode extends Node<Ts3ConfigCreds>, Ts3ConfigData {}

export interface Ts3ConfigEditorNodeProperties extends EditorNodeProperties,Ts3ConfigProps {}
