import { NodeInitializer } from "node-red"
import { Ts3ConfigNode } from "../TS3Config/types"
import { Ts3EventConfig, Ts3EventNode } from "./types"

const nodeInit: NodeInitializer = (RED): void => {
	function Ts3Event(
		this: Ts3EventNode,
		config: Ts3EventConfig
	): void {
		RED.nodes.createNode(this, config)

		const ts3Config = RED.nodes.getNode(config.configid) as Ts3ConfigNode

		// HACK: ts3Config.on("connected") would not work because i dont know how to use typescript
		ts3Config.addListener("connected",()=>{
			this.status({fill:"green",shape:"dot",text:"Connected"})
		})

		ts3Config.addListener("disconnect",()=>{
			this.status({fill:"grey",shape:"dot",text:"not conncted"})
		})

		ts3Config.addListener("error",()=>{
			this.status({fill:"red",shape:"dot",text:"Error"})
		});
 
		(async() =>{
			const client = await ts3Config.getConnection()

			// HACK: like above i dont know how to use typescript
			client.addListener(config.selection,(event: any)=>{
				const msg = {
					payload: event
				}

				this.send(msg) 
			})
			
		})()

	}

	RED.nodes.registerType("TS3Event", Ts3Event)
}

export = nodeInit;
